#!/usr/bin/perl -w

###########################################
# Program : getseq.pl
# Auto-Primer ver 1.00 - Dec. 6, 2012
# Copyright (c) 2012, NRIFS-FRA
# FRA-bioinfo@ml.affrc.go.jp
# http://nrifs.fra.affrc.go.jp/index.html
###########################################

if ( @ARGV < 2 ) { die  "Arguments : $0  FASTA  LIST  (header_lines)\n" ; } 

my $fasta = shift ; 
my $list  = shift ; 
my $header = 0 ;
while ( $opt = shift ) { 
	$header = $opt ; 
}

my @data = ` grep \'^[^\ \#]\' $list ` ; 
my %hash ;
my $i = 0 ; 
while ( $i < $header ) {
	shift(@data) ; 
	$i++ ;
}
if ( @data < 1 ) { die  "$list : No gene name is defined.\n" ; } 
foreach ( @data ) {
	/^(\S+)/ ;
	$hash{$1} = 1 ;
}

open ( IN, $fasta ) ; 
my $name = <IN> ;
if ( $name =~ /^>/ ) {
} else {
	die  "$fasta : The first line is invalid.\n" ; 
}
$name =~ /^\>(\S+)/ ;
my $id = $1 ; 
my $seq = "" ;
my $t = 1 ; 
$i = 0 ;
while ( <IN> ) { 
	if ( /^\>/ ) { 
		$t++ ;
		if ( defined $hash{$id} ) { 
			print  $name ;
			print  $seq ; 
			$i++ ;
		}
		$seq = "" ; 
		$name = $_ ;
		$name =~ /^\>(\S+)/ ;
		$id = $1 ;
		next ; 
	}
	$seq .= $_ ;
}
close ( IN ) ; 

if ( defined $hash{$id} ) {
	print  $name ;
	print  $seq ;
	$i++ ;
}

print  STDERR  "$list : ". scalar(@data) ." genes\n" ; 
print  STDERR  "$i \/ $t are selected\n" ; 

