#!/usr/bin/perl -w

###########################################
# Program : split_fasta.pl
# Auto-Primer ver 1.00 - Dec. 6, 2012
# Copyright (c) 2012, NRIFS-FRA
# FRA-bioinfo@ml.affrc.go.jp
# http://nrifs.fra.affrc.go.jp/index.html
###########################################

if ( @ARGV < 3 ) { 
	warn  "Arguments : $0  FASTA  ALL_SECTIONS  SECTION\n" ; 
	warn  "SECTION must be 0 - ALL_SECTIONS-1\n" ; 
	exit ( 0 ) ;
}

my $fasta = $ARGV[0] ;
my $all_sections = $ARGV[1] ;
my $section = $ARGV[2] ;


if ( $section < $all_sections ) {
} else {
	die  "Section must be 0 - ALL_SECTIONS-1\n" ; 
}

my $total ;
if ( $fasta =~ /\.(Z|gz)$/ ) { 
	$total = ` zgrep -c \'^\>\' $fasta ` ;
} else {
	$total = ` grep -c \'^\>\' $fasta ` ;
}
chomp ( $total ) ; 

#print  STDERR  $total."\n" ; 

my $shou = int ( $total / $all_sections ) ; 
my $amari = $total % $all_sections ;

my $start = 0 ; 
for ( $i = 0 ; $i < $section ; $i++ ) { 
	$start += $shou ;
	if ( $i < $amari ) { 
		$start++ ;
	}
}
my $end = $start + $shou ;
if ( $section < $amari ) { $end++ ; }

if ( $fasta =~ /\.(Z|gz)$/ ) { 
	open ( IN, "zcat $fasta |" ) ;
} else {
	open ( IN, "$fasta" ) ;
}
my $count = -1 ;
while ( <IN> ) { 
	if ( /^\>\S+/ ) { 
		$count++ ;
		if ( $count < $start ) { next ; } 
		print  $_ ;
		while ( <IN> ) { 
			if ( /^\>\S+/ ) { 
				$count++ ;
				if ( $count == $end ) { last ; } 
			}
			print  $_ ;
		}
		last ; 
	}
}
close ( IN ) ;

exit(0) ;



#print  $start."\-".$end."\n" ; 
$t = 0 ; 
for ( $k = 0 ; $k < $all_sections ; $k++ ) { 
	$start = 0 ; 
	for ( $i = 0 ; $i < $k ; $i++ ) { 
		$start += $shou ;
		if ( $i < $amari ) { 
			$start++ ;
		}
	}
	$end = $start + $shou ;
	if ( $k < $amari ) { $end++ ; }

	print  STDERR  $k."\t".$start."\-".$end."\t" ; 
	$tmp = $end - $start ;
	print  STDERR  $tmp."\n" ; 
	$t += $tmp ;
}
print  STDERR  $t."\n" ; 


